import { NgtCommonTexture, coerceNumberProperty, provideCommonTextureRef } from '@angular-three/core';
import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy, Input, NgModule } from '@angular/core';
import * as THREE from 'three';

// GENERATED
class NgtCanvasTexture extends NgtCommonTexture {
    get textureType() {
        return THREE.CanvasTexture;
    }
    set canvas(canvas) {
        this.set({ canvas });
    }
    set mapping(mapping) {
        this.set({ mapping });
    }
    set wrapS(wrapS) {
        this.set({ wrapS });
    }
    set wrapT(wrapT) {
        this.set({ wrapT });
    }
    set magFilter(magFilter) {
        this.set({ magFilter });
    }
    set minFilter(minFilter) {
        this.set({ minFilter });
    }
    set format(format) {
        this.set({ format });
    }
    set type(type) {
        this.set({ type });
    }
    set anisotropy(anisotropy) {
        this.set({ anisotropy: coerceNumberProperty(anisotropy) });
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { canvas: false, mapping: true, wrapS: true, wrapT: true, magFilter: true, minFilter: true, format: true, type: true, anisotropy: true });
    }
}
NgtCanvasTexture.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtCanvasTexture, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtCanvasTexture.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.10", type: NgtCanvasTexture, selector: "ngt-canvas-texture", inputs: { canvas: "canvas", mapping: "mapping", wrapS: "wrapS", wrapT: "wrapT", magFilter: "magFilter", minFilter: "minFilter", format: "format", type: "type", anisotropy: "anisotropy" }, providers: [provideCommonTextureRef(NgtCanvasTexture)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtCanvasTexture, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-canvas-texture',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonTextureRef(NgtCanvasTexture)],
                }]
        }], propDecorators: { canvas: [{
                type: Input
            }], mapping: [{
                type: Input
            }], wrapS: [{
                type: Input
            }], wrapT: [{
                type: Input
            }], magFilter: [{
                type: Input
            }], minFilter: [{
                type: Input
            }], format: [{
                type: Input
            }], type: [{
                type: Input
            }], anisotropy: [{
                type: Input
            }] } });
class NgtCanvasTextureModule {
}
NgtCanvasTextureModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtCanvasTextureModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtCanvasTextureModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtCanvasTextureModule, declarations: [NgtCanvasTexture], exports: [NgtCanvasTexture] });
NgtCanvasTextureModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtCanvasTextureModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtCanvasTextureModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtCanvasTexture],
                    exports: [NgtCanvasTexture],
                }]
        }] });

// GENERATED
class NgtCompressedTexture extends NgtCommonTexture {
    get textureType() {
        return THREE.CompressedTexture;
    }
    set mipmaps(mipmaps) {
        this.set({ mipmaps });
    }
    set width(width) {
        this.set({ width: coerceNumberProperty(width) });
    }
    set height(height) {
        this.set({ height: coerceNumberProperty(height) });
    }
    set format(format) {
        this.set({ format });
    }
    set type(type) {
        this.set({ type });
    }
    set mapping(mapping) {
        this.set({ mapping });
    }
    set wrapS(wrapS) {
        this.set({ wrapS });
    }
    set wrapT(wrapT) {
        this.set({ wrapT });
    }
    set magFilter(magFilter) {
        this.set({ magFilter });
    }
    set minFilter(minFilter) {
        this.set({ minFilter });
    }
    set anisotropy(anisotropy) {
        this.set({ anisotropy: coerceNumberProperty(anisotropy) });
    }
    set encoding(encoding) {
        this.set({ encoding });
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { mipmaps: false, width: false, height: false, format: true, type: true, mapping: true, wrapS: true, wrapT: true, magFilter: true, minFilter: true, anisotropy: true, encoding: true });
    }
}
NgtCompressedTexture.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtCompressedTexture, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtCompressedTexture.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.10", type: NgtCompressedTexture, selector: "ngt-compressed-texture", inputs: { mipmaps: "mipmaps", width: "width", height: "height", format: "format", type: "type", mapping: "mapping", wrapS: "wrapS", wrapT: "wrapT", magFilter: "magFilter", minFilter: "minFilter", anisotropy: "anisotropy", encoding: "encoding" }, providers: [provideCommonTextureRef(NgtCompressedTexture)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtCompressedTexture, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-compressed-texture',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonTextureRef(NgtCompressedTexture)],
                }]
        }], propDecorators: { mipmaps: [{
                type: Input
            }], width: [{
                type: Input
            }], height: [{
                type: Input
            }], format: [{
                type: Input
            }], type: [{
                type: Input
            }], mapping: [{
                type: Input
            }], wrapS: [{
                type: Input
            }], wrapT: [{
                type: Input
            }], magFilter: [{
                type: Input
            }], minFilter: [{
                type: Input
            }], anisotropy: [{
                type: Input
            }], encoding: [{
                type: Input
            }] } });
class NgtCompressedTextureModule {
}
NgtCompressedTextureModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtCompressedTextureModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtCompressedTextureModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtCompressedTextureModule, declarations: [NgtCompressedTexture], exports: [NgtCompressedTexture] });
NgtCompressedTextureModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtCompressedTextureModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtCompressedTextureModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtCompressedTexture],
                    exports: [NgtCompressedTexture],
                }]
        }] });

// GENERATED
class NgtCubeTexture extends NgtCommonTexture {
    get textureType() {
        return THREE.CubeTexture;
    }
    set images(images) {
        this.set({ images });
    }
    set mapping(mapping) {
        this.set({ mapping });
    }
    set wrapS(wrapS) {
        this.set({ wrapS });
    }
    set wrapT(wrapT) {
        this.set({ wrapT });
    }
    set magFilter(magFilter) {
        this.set({ magFilter });
    }
    set minFilter(minFilter) {
        this.set({ minFilter });
    }
    set format(format) {
        this.set({ format });
    }
    set type(type) {
        this.set({ type });
    }
    set anisotropy(anisotropy) {
        this.set({ anisotropy: coerceNumberProperty(anisotropy) });
    }
    set encoding(encoding) {
        this.set({ encoding });
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { images: true, mapping: true, wrapS: true, wrapT: true, magFilter: true, minFilter: true, format: true, type: true, anisotropy: true, encoding: true });
    }
}
NgtCubeTexture.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtCubeTexture, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtCubeTexture.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.10", type: NgtCubeTexture, selector: "ngt-cube-texture", inputs: { images: "images", mapping: "mapping", wrapS: "wrapS", wrapT: "wrapT", magFilter: "magFilter", minFilter: "minFilter", format: "format", type: "type", anisotropy: "anisotropy", encoding: "encoding" }, providers: [provideCommonTextureRef(NgtCubeTexture)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtCubeTexture, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-cube-texture',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonTextureRef(NgtCubeTexture)],
                }]
        }], propDecorators: { images: [{
                type: Input
            }], mapping: [{
                type: Input
            }], wrapS: [{
                type: Input
            }], wrapT: [{
                type: Input
            }], magFilter: [{
                type: Input
            }], minFilter: [{
                type: Input
            }], format: [{
                type: Input
            }], type: [{
                type: Input
            }], anisotropy: [{
                type: Input
            }], encoding: [{
                type: Input
            }] } });
class NgtCubeTextureModule {
}
NgtCubeTextureModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtCubeTextureModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtCubeTextureModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtCubeTextureModule, declarations: [NgtCubeTexture], exports: [NgtCubeTexture] });
NgtCubeTextureModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtCubeTextureModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtCubeTextureModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtCubeTexture],
                    exports: [NgtCubeTexture],
                }]
        }] });

// GENERATED
class NgtDataTexture extends NgtCommonTexture {
    get textureType() {
        return THREE.DataTexture;
    }
    set data(data) {
        this.set({ data });
    }
    set width(width) {
        this.set({ width: coerceNumberProperty(width) });
    }
    set height(height) {
        this.set({ height: coerceNumberProperty(height) });
    }
    set format(format) {
        this.set({ format });
    }
    set type(type) {
        this.set({ type });
    }
    set mapping(mapping) {
        this.set({ mapping });
    }
    set wrapS(wrapS) {
        this.set({ wrapS });
    }
    set wrapT(wrapT) {
        this.set({ wrapT });
    }
    set magFilter(magFilter) {
        this.set({ magFilter });
    }
    set minFilter(minFilter) {
        this.set({ minFilter });
    }
    set anisotropy(anisotropy) {
        this.set({ anisotropy: coerceNumberProperty(anisotropy) });
    }
    set encoding(encoding) {
        this.set({ encoding });
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { data: true, width: true, height: true, format: true, type: true, mapping: true, wrapS: true, wrapT: true, magFilter: true, minFilter: true, anisotropy: true, encoding: true });
    }
}
NgtDataTexture.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtDataTexture, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtDataTexture.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.10", type: NgtDataTexture, selector: "ngt-data-texture", inputs: { data: "data", width: "width", height: "height", format: "format", type: "type", mapping: "mapping", wrapS: "wrapS", wrapT: "wrapT", magFilter: "magFilter", minFilter: "minFilter", anisotropy: "anisotropy", encoding: "encoding" }, providers: [provideCommonTextureRef(NgtDataTexture)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtDataTexture, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-data-texture',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonTextureRef(NgtDataTexture)],
                }]
        }], propDecorators: { data: [{
                type: Input
            }], width: [{
                type: Input
            }], height: [{
                type: Input
            }], format: [{
                type: Input
            }], type: [{
                type: Input
            }], mapping: [{
                type: Input
            }], wrapS: [{
                type: Input
            }], wrapT: [{
                type: Input
            }], magFilter: [{
                type: Input
            }], minFilter: [{
                type: Input
            }], anisotropy: [{
                type: Input
            }], encoding: [{
                type: Input
            }] } });
class NgtDataTextureModule {
}
NgtDataTextureModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtDataTextureModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtDataTextureModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtDataTextureModule, declarations: [NgtDataTexture], exports: [NgtDataTexture] });
NgtDataTextureModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtDataTextureModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtDataTextureModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtDataTexture],
                    exports: [NgtDataTexture],
                }]
        }] });

// GENERATED
class NgtDataArrayTexture extends NgtCommonTexture {
    get textureType() {
        return THREE.DataArrayTexture;
    }
    set data(data) {
        this.set({ data });
    }
    set width(width) {
        this.set({ width: coerceNumberProperty(width) });
    }
    set height(height) {
        this.set({ height: coerceNumberProperty(height) });
    }
    set depth(depth) {
        this.set({ depth: coerceNumberProperty(depth) });
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { data: true, width: true, height: true, depth: true });
    }
}
NgtDataArrayTexture.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtDataArrayTexture, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtDataArrayTexture.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.10", type: NgtDataArrayTexture, selector: "ngt-data-array-texture", inputs: { data: "data", width: "width", height: "height", depth: "depth" }, providers: [provideCommonTextureRef(NgtDataArrayTexture)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtDataArrayTexture, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-data-array-texture',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonTextureRef(NgtDataArrayTexture)],
                }]
        }], propDecorators: { data: [{
                type: Input
            }], width: [{
                type: Input
            }], height: [{
                type: Input
            }], depth: [{
                type: Input
            }] } });
class NgtDataArrayTextureModule {
}
NgtDataArrayTextureModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtDataArrayTextureModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtDataArrayTextureModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtDataArrayTextureModule, declarations: [NgtDataArrayTexture], exports: [NgtDataArrayTexture] });
NgtDataArrayTextureModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtDataArrayTextureModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtDataArrayTextureModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtDataArrayTexture],
                    exports: [NgtDataArrayTexture],
                }]
        }] });

// GENERATED
class NgtData3DTexture extends NgtCommonTexture {
    get textureType() {
        return THREE.Data3DTexture;
    }
    set data(data) {
        this.set({ data });
    }
    set width(width) {
        this.set({ width: coerceNumberProperty(width) });
    }
    set height(height) {
        this.set({ height: coerceNumberProperty(height) });
    }
    set depth(depth) {
        this.set({ depth: coerceNumberProperty(depth) });
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { data: false, width: false, height: false, depth: false });
    }
}
NgtData3DTexture.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtData3DTexture, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtData3DTexture.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.10", type: NgtData3DTexture, selector: "ngt-data3-dtexture", inputs: { data: "data", width: "width", height: "height", depth: "depth" }, providers: [provideCommonTextureRef(NgtData3DTexture)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtData3DTexture, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-data3-dtexture',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonTextureRef(NgtData3DTexture)],
                }]
        }], propDecorators: { data: [{
                type: Input
            }], width: [{
                type: Input
            }], height: [{
                type: Input
            }], depth: [{
                type: Input
            }] } });
class NgtData3DTextureModule {
}
NgtData3DTextureModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtData3DTextureModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtData3DTextureModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtData3DTextureModule, declarations: [NgtData3DTexture], exports: [NgtData3DTexture] });
NgtData3DTextureModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtData3DTextureModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtData3DTextureModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtData3DTexture],
                    exports: [NgtData3DTexture],
                }]
        }] });

// GENERATED
class NgtDepthTexture extends NgtCommonTexture {
    get textureType() {
        return THREE.DepthTexture;
    }
    set width(width) {
        this.set({ width: coerceNumberProperty(width) });
    }
    set height(height) {
        this.set({ height: coerceNumberProperty(height) });
    }
    set type(type) {
        this.set({ type });
    }
    set mapping(mapping) {
        this.set({ mapping });
    }
    set wrapS(wrapS) {
        this.set({ wrapS });
    }
    set wrapT(wrapT) {
        this.set({ wrapT });
    }
    set magFilter(magFilter) {
        this.set({ magFilter });
    }
    set minFilter(minFilter) {
        this.set({ minFilter });
    }
    set anisotropy(anisotropy) {
        this.set({ anisotropy: coerceNumberProperty(anisotropy) });
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { width: false, height: false, type: true, mapping: true, wrapS: true, wrapT: true, magFilter: true, minFilter: true, anisotropy: true });
    }
}
NgtDepthTexture.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtDepthTexture, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtDepthTexture.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.10", type: NgtDepthTexture, selector: "ngt-depth-texture", inputs: { width: "width", height: "height", type: "type", mapping: "mapping", wrapS: "wrapS", wrapT: "wrapT", magFilter: "magFilter", minFilter: "minFilter", anisotropy: "anisotropy" }, providers: [provideCommonTextureRef(NgtDepthTexture)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtDepthTexture, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-depth-texture',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonTextureRef(NgtDepthTexture)],
                }]
        }], propDecorators: { width: [{
                type: Input
            }], height: [{
                type: Input
            }], type: [{
                type: Input
            }], mapping: [{
                type: Input
            }], wrapS: [{
                type: Input
            }], wrapT: [{
                type: Input
            }], magFilter: [{
                type: Input
            }], minFilter: [{
                type: Input
            }], anisotropy: [{
                type: Input
            }] } });
class NgtDepthTextureModule {
}
NgtDepthTextureModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtDepthTextureModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtDepthTextureModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtDepthTextureModule, declarations: [NgtDepthTexture], exports: [NgtDepthTexture] });
NgtDepthTextureModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtDepthTextureModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtDepthTextureModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtDepthTexture],
                    exports: [NgtDepthTexture],
                }]
        }] });

// GENERATED
class NgtVideoTexture extends NgtCommonTexture {
    get textureType() {
        return THREE.VideoTexture;
    }
    set video(video) {
        this.set({ video });
    }
    set mapping(mapping) {
        this.set({ mapping });
    }
    set wrapS(wrapS) {
        this.set({ wrapS });
    }
    set wrapT(wrapT) {
        this.set({ wrapT });
    }
    set magFilter(magFilter) {
        this.set({ magFilter });
    }
    set minFilter(minFilter) {
        this.set({ minFilter });
    }
    set format(format) {
        this.set({ format });
    }
    set type(type) {
        this.set({ type });
    }
    set anisotropy(anisotropy) {
        this.set({ anisotropy: coerceNumberProperty(anisotropy) });
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { video: false, mapping: true, wrapS: true, wrapT: true, magFilter: true, minFilter: true, format: true, type: true, anisotropy: true });
    }
}
NgtVideoTexture.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtVideoTexture, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtVideoTexture.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.10", type: NgtVideoTexture, selector: "ngt-video-texture", inputs: { video: "video", mapping: "mapping", wrapS: "wrapS", wrapT: "wrapT", magFilter: "magFilter", minFilter: "minFilter", format: "format", type: "type", anisotropy: "anisotropy" }, providers: [provideCommonTextureRef(NgtVideoTexture)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtVideoTexture, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-video-texture',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonTextureRef(NgtVideoTexture)],
                }]
        }], propDecorators: { video: [{
                type: Input
            }], mapping: [{
                type: Input
            }], wrapS: [{
                type: Input
            }], wrapT: [{
                type: Input
            }], magFilter: [{
                type: Input
            }], minFilter: [{
                type: Input
            }], format: [{
                type: Input
            }], type: [{
                type: Input
            }], anisotropy: [{
                type: Input
            }] } });
class NgtVideoTextureModule {
}
NgtVideoTextureModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtVideoTextureModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtVideoTextureModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtVideoTextureModule, declarations: [NgtVideoTexture], exports: [NgtVideoTexture] });
NgtVideoTextureModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtVideoTextureModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtVideoTextureModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtVideoTexture],
                    exports: [NgtVideoTexture],
                }]
        }] });

// GENERATED

/**
 * Generated bundle index. Do not edit.
 */

export { NgtCanvasTexture, NgtCanvasTextureModule, NgtCompressedTexture, NgtCompressedTextureModule, NgtCubeTexture, NgtCubeTextureModule, NgtData3DTexture, NgtData3DTextureModule, NgtDataArrayTexture, NgtDataArrayTextureModule, NgtDataTexture, NgtDataTextureModule, NgtDepthTexture, NgtDepthTextureModule, NgtVideoTexture, NgtVideoTextureModule };
//# sourceMappingURL=angular-three-core-textures.mjs.map
