import * as i1 from '@angular-three/core';
import { NgtCommonMesh, provideCommonMeshRef, coerceNumberProperty, coerceBooleanProperty, make, NgtInstance, tapEffect, NGT_HOST_SKINNED_MESH_REF, provideInstanceRef, NgtObject, NGT_HOST_BONE_REF, NGT_HOST_SKELETON_REF, provideObjectRef } from '@angular-three/core';
import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy, NgModule, Input, Optional, SkipSelf, Inject } from '@angular/core';
import * as THREE from 'three';
import { pipe, withLatestFrom } from 'rxjs';

class NgtMesh extends NgtCommonMesh {
    get meshType() {
        return THREE.Mesh;
    }
}
NgtMesh.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtMesh, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtMesh.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.10", type: NgtMesh, selector: "ngt-mesh", providers: [provideCommonMeshRef(NgtMesh)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtMesh, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-mesh',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonMeshRef(NgtMesh)],
                }]
        }] });
class NgtMeshModule {
}
NgtMeshModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtMeshModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtMeshModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtMeshModule, declarations: [NgtMesh], exports: [NgtMesh] });
NgtMeshModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtMeshModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtMeshModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtMesh],
                    exports: [NgtMesh],
                }]
        }] });

class NgtInstancedMesh extends NgtCommonMesh {
    set count(count) {
        this.set({ count: coerceNumberProperty(count) });
    }
    get meshType() {
        return THREE.InstancedMesh;
    }
    postPrepare(instancedMesh) {
        instancedMesh.instanceMatrix.setUsage(THREE.DynamicDrawUsage);
    }
    get optionFields() {
        return { ...super.optionFields, count: false };
    }
    get argsKeys() {
        return ['count'];
    }
}
NgtInstancedMesh.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtInstancedMesh, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtInstancedMesh.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.10", type: NgtInstancedMesh, selector: "ngt-instanced-mesh[count]", inputs: { count: "count" }, providers: [provideCommonMeshRef(NgtInstancedMesh)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtInstancedMesh, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-instanced-mesh[count]',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonMeshRef(NgtInstancedMesh)],
                }]
        }], propDecorators: { count: [{
                type: Input
            }] } });
class NgtInstancedMeshModule {
}
NgtInstancedMeshModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtInstancedMeshModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtInstancedMeshModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtInstancedMeshModule, declarations: [NgtInstancedMesh], exports: [NgtInstancedMesh] });
NgtInstancedMeshModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtInstancedMeshModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtInstancedMeshModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtInstancedMesh],
                    exports: [NgtInstancedMesh],
                }]
        }] });

class NgtSkinnedMesh extends NgtCommonMesh {
    set skeleton(skeleton) {
        this.set({ skeleton });
    }
    set useVertexTexture(useVertexTexture) {
        this.set({ useVertexTexture: coerceBooleanProperty(useVertexTexture) });
    }
    set bindMatrix(bindMatrix) {
        this.set({ bindMatrix: make(THREE.Matrix4, bindMatrix) });
    }
    set bindMatrixInverse(bindMatrixInverse) {
        this.set({
            bindMatrixInverse: make(THREE.Matrix4, bindMatrixInverse),
        });
    }
    set bindMode(bindMode) {
        this.set({ bindMode });
    }
    get meshType() {
        return THREE.SkinnedMesh;
    }
    get argsKeys() {
        return ['useVertexTexture'];
    }
    get optionFields() {
        return {
            ...super.optionFields,
            bindMatrix: true,
            bindMatrixInverse: true,
            bindMode: true,
            skeleton: true,
        };
    }
    bind(skeleton) {
        this.instance.value.bind(skeleton, this.get((s) => s['bindMatrix']));
    }
}
NgtSkinnedMesh.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtSkinnedMesh, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtSkinnedMesh.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.10", type: NgtSkinnedMesh, selector: "ngt-skinned-mesh", inputs: { skeleton: "skeleton", useVertexTexture: "useVertexTexture", bindMatrix: "bindMatrix", bindMatrixInverse: "bindMatrixInverse", bindMode: "bindMode" }, providers: [provideCommonMeshRef(NgtSkinnedMesh)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtSkinnedMesh, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-skinned-mesh',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonMeshRef(NgtSkinnedMesh)],
                }]
        }], propDecorators: { skeleton: [{
                type: Input
            }], useVertexTexture: [{
                type: Input
            }], bindMatrix: [{
                type: Input
            }], bindMatrixInverse: [{
                type: Input
            }], bindMode: [{
                type: Input
            }] } });
class NgtSkeleton extends NgtInstance {
    constructor(zone, store, parentHostRef, skinnedMesh) {
        if (parentHostRef && !parentHostRef().value.isSkinnedMesh) {
            throw new Error('<ngt-skeleton> can only be used within <ngt-skinned-mesh>');
        }
        super(zone, store, () => skinnedMesh?.instance, parentHostRef);
        this.skinnedMesh = skinnedMesh;
        this.init = this.effect(pipe(withLatestFrom(this.select(this.select((s) => s.bones), this.select((s) => s.boneInverses), (bones, boneInverses) => ({ bones, boneInverses }))), tapEffect(([instanceArgs, { bones, boneInverses }]) => {
            const skeletonArgs = [...instanceArgs];
            if (skeletonArgs.length === 0) {
                if (bones.length) {
                    skeletonArgs[0] = bones;
                }
                if (boneInverses.length) {
                    skeletonArgs[1] = boneInverses;
                }
            }
            const skeleton = this.prepareInstance(new THREE.Skeleton(...skeletonArgs));
            if (!this.skinnedMesh.instance.value.skeleton) {
                this.skinnedMesh.bind(skeleton);
            }
            return () => {
                skeleton.dispose();
            };
        })));
    }
    set args(args) {
        this.set({ instanceArgs: args });
    }
    set bones(bones) {
        this.set({ bones });
    }
    set boneInverses(boneInverses) {
        this.set({
            boneInverses: boneInverses.map((datum) => make(THREE.Matrix4, datum)),
        });
    }
    set boneMatrices(boneMatrices) {
        this.set({ boneMatrices });
    }
    set boneTexture(boneTexture) {
        this.set({ boneTexture });
    }
    set boneTextureSize(boneTextureSize) {
        this.set({ boneTextureSize: coerceNumberProperty(boneTextureSize) });
    }
    set frame(frame) {
        this.set({ frame: coerceNumberProperty(frame) });
    }
    preInit() {
        this.set((state) => ({
            attach: state.attach.length ? state.attach : ['skeleton'],
            bones: state.bones || [],
            boneInverses: state.boneInverses || [],
            boneMatrices: state.boneMatrices || null,
            boneTexture: state.boneTexture || null,
            boneTextureSize: state.boneTextureSize || 0,
            frame: state.frame || -1,
        }));
    }
    ngOnInit() {
        super.ngOnInit();
        this.onCanvasReady(this.store.ready$, () => {
            this.init(this.instanceArgs$);
        });
    }
    get optionFields() {
        return {
            ...super.optionFields,
            bones: false,
            boneTexture: false,
            boneTextureSize: false,
            boneMatrices: false,
            boneInverses: false,
            frame: false,
        };
    }
}
NgtSkeleton.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtSkeleton, deps: [{ token: i0.NgZone }, { token: i1.NgtStore }, { token: NGT_HOST_SKINNED_MESH_REF, optional: true, skipSelf: true }, { token: NgtSkinnedMesh, optional: true }], target: i0.ɵɵFactoryTarget.Component });
NgtSkeleton.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.10", type: NgtSkeleton, selector: "ngt-skeleton", inputs: { args: "args", bones: "bones", boneInverses: "boneInverses", boneMatrices: "boneMatrices", boneTexture: "boneTexture", boneTextureSize: "boneTextureSize", frame: "frame" }, providers: [provideInstanceRef(NgtSkeleton)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtSkeleton, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-skeleton',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideInstanceRef(NgtSkeleton)],
                }]
        }], ctorParameters: function () { return [{ type: i0.NgZone }, { type: i1.NgtStore }, { type: undefined, decorators: [{
                    type: Optional
                }, {
                    type: SkipSelf
                }, {
                    type: Inject,
                    args: [NGT_HOST_SKINNED_MESH_REF]
                }] }, { type: NgtSkinnedMesh, decorators: [{
                    type: Optional
                }] }]; }, propDecorators: { args: [{
                type: Input
            }], bones: [{
                type: Input
            }], boneInverses: [{
                type: Input
            }], boneMatrices: [{
                type: Input
            }], boneTexture: [{
                type: Input
            }], boneTextureSize: [{
                type: Input
            }], frame: [{
                type: Input
            }] } });
class NgtBone extends NgtObject {
    constructor(zone, store, parentBone, parentSkinnedMesh, parentSkeleton, hostBoneRef, hostSkeletonRef, hostSkinnedMeshRef) {
        super(zone, store, () => (parentBone?.instance || parentSkinnedMesh?.instance), (hostBoneRef || hostSkinnedMeshRef));
        this.parentBone = parentBone;
        this.parentSkinnedMesh = parentSkinnedMesh;
        this.parentSkeleton = parentSkeleton;
        this.hostBoneRef = hostBoneRef;
        this.hostSkeletonRef = hostSkeletonRef;
        this.hostSkinnedMeshRef = hostSkinnedMeshRef;
    }
    objectInitFn() {
        return new THREE.Bone();
    }
    postPrepare(bone) {
        if (this.parentSkeleton) {
            this.parentSkeleton.instance.value.bones.push(bone);
        }
        else if (this.hostSkeletonRef) {
            this.hostSkeletonRef().value.bones.push(bone);
        }
    }
}
NgtBone.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtBone, deps: [{ token: i0.NgZone }, { token: i1.NgtStore }, { token: NgtBone, optional: true, skipSelf: true }, { token: NgtSkinnedMesh, optional: true }, { token: NgtSkeleton, optional: true }, { token: NGT_HOST_BONE_REF, optional: true, skipSelf: true }, { token: NGT_HOST_SKELETON_REF, optional: true, skipSelf: true }, { token: NGT_HOST_SKINNED_MESH_REF, optional: true, skipSelf: true }], target: i0.ɵɵFactoryTarget.Component });
NgtBone.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.10", type: NgtBone, selector: "ngt-bone", providers: [provideObjectRef(NgtBone)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtBone, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-bone',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideObjectRef(NgtBone)],
                }]
        }], ctorParameters: function () { return [{ type: i0.NgZone }, { type: i1.NgtStore }, { type: NgtBone, decorators: [{
                    type: Optional
                }, {
                    type: SkipSelf
                }] }, { type: NgtSkinnedMesh, decorators: [{
                    type: Optional
                }] }, { type: NgtSkeleton, decorators: [{
                    type: Optional
                }] }, { type: undefined, decorators: [{
                    type: Optional
                }, {
                    type: SkipSelf
                }, {
                    type: Inject,
                    args: [NGT_HOST_BONE_REF]
                }] }, { type: undefined, decorators: [{
                    type: Optional
                }, {
                    type: SkipSelf
                }, {
                    type: Inject,
                    args: [NGT_HOST_SKELETON_REF]
                }] }, { type: undefined, decorators: [{
                    type: Optional
                }, {
                    type: SkipSelf
                }, {
                    type: Inject,
                    args: [NGT_HOST_SKINNED_MESH_REF]
                }] }]; } });
class NgtSkinnedMeshModule {
}
NgtSkinnedMeshModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtSkinnedMeshModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtSkinnedMeshModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtSkinnedMeshModule, declarations: [NgtSkinnedMesh, NgtSkeleton, NgtBone], exports: [NgtSkinnedMesh, NgtSkeleton, NgtBone] });
NgtSkinnedMeshModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtSkinnedMeshModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.10", ngImport: i0, type: NgtSkinnedMeshModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtSkinnedMesh, NgtSkeleton, NgtBone],
                    exports: [NgtSkinnedMesh, NgtSkeleton, NgtBone],
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { NgtBone, NgtInstancedMesh, NgtInstancedMeshModule, NgtMesh, NgtMeshModule, NgtSkeleton, NgtSkinnedMesh, NgtSkinnedMeshModule };
//# sourceMappingURL=angular-three-core-meshes.mjs.map
